<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:35 CEST 2019 -->
<title>AbstractNativeDatabaseFactory (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="AbstractNativeDatabaseFactory (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":6,"i2":10,"i3":10,"i4":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../org/firebirdsql/gds/ng/jna/BigEndianDatatypeCoder.html" title="class in org.firebirdsql.gds.ng.jna"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html" target="_top">Frames</a></li>
<li><a href="AbstractNativeDatabaseFactory.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng.jna</div>
<h2 title="Class AbstractNativeDatabaseFactory" class="title">Class AbstractNativeDatabaseFactory</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.gds.ng.jna.AbstractNativeDatabaseFactory</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html" title="interface in org.firebirdsql.gds.ng">FbDatabaseFactory</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../../../org/firebirdsql/gds/ng/jna/FbClientDatabaseFactory.html" title="class in org.firebirdsql.gds.ng.jna">FbClientDatabaseFactory</a>, <a href="../../../../../org/firebirdsql/gds/ng/jna/FbEmbeddedDatabaseFactory.html" title="class in org.firebirdsql.gds.ng.jna">FbEmbeddedDatabaseFactory</a>, <a href="../../../../../org/firebirdsql/gds/ng/jna/FbLocalDatabaseFactory.html" title="class in org.firebirdsql.gds.ng.jna">FbLocalDatabaseFactory</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="typeNameLabel">AbstractNativeDatabaseFactory</span>
extends <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html" title="interface in org.firebirdsql.gds.ng">FbDatabaseFactory</a></pre>
<div class="block">Common implementation for client library and embedded database factory.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html#AbstractNativeDatabaseFactory--">AbstractNativeDatabaseFactory</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/firebirdsql/gds/ng/jna/JnaDatabase.html" title="class in org.firebirdsql.gds.ng.jna">JnaDatabase</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html#connect-org.firebirdsql.gds.ng.IConnectionProperties-">connect</a></span>(<a href="../../../../../org/firebirdsql/gds/ng/IConnectionProperties.html" title="interface in org.firebirdsql.gds.ng">IConnectionProperties</a>&nbsp;connectionProperties)</code>
<div class="block">Connects to a Firebird server based on the supplied connection properties.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>protected abstract <a href="../../../../../org/firebirdsql/jna/fbclient/FbClientLibrary.html" title="interface in org.firebirdsql.jna.fbclient">FbClientLibrary</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html#createClientLibrary--">createClientLibrary</a></span>()</code>
<div class="block">Creates and initialize a new instance of the client library.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>protected &lt;T extends <a href="../../../../../org/firebirdsql/gds/ng/IAttachProperties.html" title="interface in org.firebirdsql.gds.ng">IAttachProperties</a>&lt;T&gt;&gt;<br>T</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html#filterProperties-T-">filterProperties</a></span>(T&nbsp;attachProperties)</code>
<div class="block">Allows the database factory to perform modification of the attach properties before use.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../org/firebirdsql/jna/fbclient/FbClientLibrary.html" title="interface in org.firebirdsql.jna.fbclient">FbClientLibrary</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html#getClientLibrary--">getClientLibrary</a></span>()</code>
<div class="block">Gets the current instance of the client library.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/firebirdsql/gds/ng/jna/JnaService.html" title="class in org.firebirdsql.gds.ng.jna">JnaService</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html#serviceConnect-org.firebirdsql.gds.ng.IServiceProperties-">serviceConnect</a></span>(<a href="../../../../../org/firebirdsql/gds/ng/IServiceProperties.html" title="interface in org.firebirdsql.gds.ng">IServiceProperties</a>&nbsp;serviceProperties)</code>
<div class="block">Connects to the service manager of a Firebird server with the supplied service properties.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="AbstractNativeDatabaseFactory--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>AbstractNativeDatabaseFactory</h4>
<pre>public&nbsp;AbstractNativeDatabaseFactory()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="connect-org.firebirdsql.gds.ng.IConnectionProperties-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connect</h4>
<pre>public&nbsp;<a href="../../../../../org/firebirdsql/gds/ng/jna/JnaDatabase.html" title="class in org.firebirdsql.gds.ng.jna">JnaDatabase</a>&nbsp;connect(<a href="../../../../../org/firebirdsql/gds/ng/IConnectionProperties.html" title="interface in org.firebirdsql.gds.ng">IConnectionProperties</a>&nbsp;connectionProperties)
                    throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html#connect-org.firebirdsql.gds.ng.IConnectionProperties-">FbDatabaseFactory</a></code></span></div>
<div class="block">Connects to a Firebird server based on the supplied connection properties.
 <p>
 The <a href="../../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng"><code>FbDatabase</code></a> instance will be connected to the server, but is not yet attached.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html#connect-org.firebirdsql.gds.ng.IConnectionProperties-">connect</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html" title="interface in org.firebirdsql.gds.ng">FbDatabaseFactory</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connectionProperties</code> - Connection properties</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Database instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="serviceConnect-org.firebirdsql.gds.ng.IServiceProperties-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>serviceConnect</h4>
<pre>public&nbsp;<a href="../../../../../org/firebirdsql/gds/ng/jna/JnaService.html" title="class in org.firebirdsql.gds.ng.jna">JnaService</a>&nbsp;serviceConnect(<a href="../../../../../org/firebirdsql/gds/ng/IServiceProperties.html" title="interface in org.firebirdsql.gds.ng">IServiceProperties</a>&nbsp;serviceProperties)
                          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html#serviceConnect-org.firebirdsql.gds.ng.IServiceProperties-">FbDatabaseFactory</a></code></span></div>
<div class="block">Connects to the service manager of a Firebird server with the supplied service properties.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html#serviceConnect-org.firebirdsql.gds.ng.IServiceProperties-">serviceConnect</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/FbDatabaseFactory.html" title="interface in org.firebirdsql.gds.ng">FbDatabaseFactory</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>serviceProperties</code> - Service properties</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Service instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="getClientLibrary--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getClientLibrary</h4>
<pre>protected&nbsp;<a href="../../../../../org/firebirdsql/jna/fbclient/FbClientLibrary.html" title="interface in org.firebirdsql.jna.fbclient">FbClientLibrary</a>&nbsp;getClientLibrary()</pre>
<div class="block">Gets the current instance of the client library.
 <p>
 Most implementations should <b>not</b> override this method (contrary to previous versions of Jaybird), to ensure
 native libraries are properly disposed of.
 </p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Client library instance.</dd>
</dl>
</li>
</ul>
<a name="createClientLibrary--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createClientLibrary</h4>
<pre>protected abstract&nbsp;<a href="../../../../../org/firebirdsql/jna/fbclient/FbClientLibrary.html" title="interface in org.firebirdsql.jna.fbclient">FbClientLibrary</a>&nbsp;createClientLibrary()</pre>
<div class="block">Creates and initialize a new instance of the client library.
 <p>
 Instances should not be cached (caching - if any - is the responsibility of the caller).
 </p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>new client library instance</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>4.0</dd>
</dl>
</li>
</ul>
<a name="filterProperties-org.firebirdsql.gds.ng.IAttachProperties-">
<!--   -->
</a><a name="filterProperties-T-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>filterProperties</h4>
<pre>protected&nbsp;&lt;T extends <a href="../../../../../org/firebirdsql/gds/ng/IAttachProperties.html" title="interface in org.firebirdsql.gds.ng">IAttachProperties</a>&lt;T&gt;&gt;&nbsp;T&nbsp;filterProperties(T&nbsp;attachProperties)</pre>
<div class="block">Allows the database factory to perform modification of the attach properties before use.
 <p>
 Implementations should be prepared to handle immutable attach properties. Implementations are strongly
 advised to copy the attach properties before modification and return this copy.
 </p></div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - Type of attach properties</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>attachProperties</code> - Attach properties</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Filtered properties</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../org/firebirdsql/gds/ng/jna/BigEndianDatatypeCoder.html" title="class in org.firebirdsql.gds.ng.jna"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/firebirdsql/gds/ng/jna/AbstractNativeDatabaseFactory.html" target="_top">Frames</a></li>
<li><a href="AbstractNativeDatabaseFactory.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
